From 71391c52c537c11d1f72473db9a6887cd4b40b81 Mon Sep 17 00:00:00 2001
From: Sarper Akdemir <sarper.akdemir@collabora.com>
Date: Sun, 28 Aug 2022 09:17:24 +0300
Subject: [PATCH] tdf#144092 pptx export: export endParaRPr for empty shape &
 cells

Alters ShapeExport::WriteTextBox so that when it is called with an empty
text (on PPTX export) an attempt to export empty text's char properties
(stored in the Shape or Cell's properties directly) made on
ShapeExport::WriteText.

These properties are exported into endParaRPr.

Implementing this caused some tests that contain connector shapes fail
with XML schema validation errors, therefore disabled export of txBody
inside cxnSp tags.

Also adds a unit test that checks roundtrip of empty shape or cell's
endParaRPr.

Change-Id: I3e3feda802f42560fa7fecc9c0b1afe73a900a84
Reviewed-on: https://gerrit.libreoffice.org/c/core/+/138960
Tested-by: Jenkins
Reviewed-by: Miklos Vajna <vmiklos@collabora.com>
(cherry picked from commit aebd3c4a7def4476f34e171fce395d6ba70e3e1e)
Reviewed-on: https://gerrit.libreoffice.org/c/core/+/139224
Tested-by: Jenkins CollaboraOffice <jenkinscollaboraoffice@gmail.com>
Reviewed-by: Sarper Akdemir <sarper.akdemir@collabora.com>
---
 oox/source/export/drawingml.cxx               |  18 ++++++++
 oox/source/export/shapes.cxx                  |  11 +++--
 .../pptx/tdf144092-emptyShapeTextProps.pptx   | Bin 0 -> 35472 bytes
 sd/qa/unit/data/xml/tdf90338_0.xml            |   2 +-
 sd/qa/unit/data/xml/tdf92001_0.xml            |   2 +-
 sd/qa/unit/export-tests-ooxml3.cxx            |  40 ++++++++++++++++++
 6 files changed, 68 insertions(+), 5 deletions(-)
 create mode 100644 sd/qa/unit/data/pptx/tdf144092-emptyShapeTextProps.pptx

diff --git a/oox/source/export/drawingml.cxx b/oox/source/export/drawingml.cxx
index 57199b4a0d24..f35596457caa 100644
--- a/oox/source/export/drawingml.cxx
+++ b/oox/source/export/drawingml.cxx
@@ -3674,6 +3674,24 @@ void DrawingML::WriteText(const Reference<XInterface>& rXIface, bool bBodyPr, bo
     sal_Int32 nCharHeight = -1;
     bool bFirstParagraph = true;

+    // tdf#144092 For shapes without text: Export run properties (into
+    // endParaRPr) from the shape's propset instead of the paragraph's.
+    if(xXText->getString().isEmpty() && enumeration->hasMoreElements())
+    {
+        Any aAny (enumeration->nextElement());
+        Reference<XTextContent> xParagraph;
+        if( aAny >>= xParagraph )
+        {
+            mpFS->startElementNS(XML_a, XML_p);
+            WriteParagraphProperties(xParagraph, nCharHeight, XML_pPr);
+            sal_Int16 nDummy = -1;
+            WriteRunProperties(rXPropSet, false, XML_endParaRPr, false,
+                               bOverridingCharHeight, nCharHeight, nDummy, rXPropSet);
+            mpFS->endElementNS(XML_a, XML_p);
+        }
+        return;
+    }
+
     while( enumeration->hasMoreElements() )
     {
         Reference< XTextContent > paragraph;
diff --git a/oox/source/export/shapes.cxx b/oox/source/export/shapes.cxx
index 5f0f04bf6bda..eeb307c1471c 100644
--- a/oox/source/export/shapes.cxx
+++ b/oox/source/export/shapes.cxx
@@ -1511,8 +1511,12 @@ ShapeExport& ShapeExport::WriteConnectorShape( const Reference< XShape >& xShape
         WriteOutline( xShapeProps );
     pFS->endElementNS( mnXmlNamespace, XML_spPr );

-    // write text
-    WriteTextBox( xShape, mnXmlNamespace );
+    // connector shape (cxnSp) cannot contain text (txBody) (according to schema)
+    if( nShapeNode != XML_cxnSp )
+    {
+        // write text
+        WriteTextBox( xShape, mnXmlNamespace );
+    }

     pFS->endElementNS(mnXmlNamespace, nShapeNode);

@@ -1721,7 +1725,8 @@ ShapeExport& ShapeExport::WriteTextBox( const Reference< XInterface >& xIface, s
     }

     Reference< XText > xXText( xIface, UNO_QUERY );
-    if( NonEmptyText( xIface ) && xXText.is() )
+    if( (NonEmptyText( xIface ) || GetDocumentType() == DOCUMENT_PPTX)
+        && xXText.is() )
     {
         FSHelperPtr pFS = GetFS();

